diff -ruN vdr-1.5.15/menu.c vdr-1.5.16/menu.c
--- vdr-1.5.15/menu.c	2008-02-16 14:53:26.000000000 +0100
+++ vdr-1.5.16/menu.c	2008-02-24 11:28:46.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menu.c 1.477 2008/02/16 13:53:26 kls Exp $
+ * $Id: menu.c 1.480 2008/02/24 10:28:46 kls Exp $
  */
 
 #include "menu.h"
@@ -1697,6 +1697,7 @@
         AddMultiLineItem(ciMenu->BottomText());
         dsyslog("CAM %d: '%s'", camSlot->SlotNumber(), ciMenu->BottomText());
         }
+     cRemote::TriggerLastActivity();
      }
   else if (ciEnquiry) {
      Clear();
@@ -2126,7 +2127,7 @@
      cRecording *recording = GetRecording(ri);
      if (recording) {
         cMenuCommands *menu;
-        eOSState state = AddSubMenu(menu = new cMenuCommands(tr("Recording commands"), &RecordingCommands, cString::sprintf("\"%s\"", *strescape(recording->FileName(), "\"$"))));
+        eOSState state = AddSubMenu(menu = new cMenuCommands(tr("Recording commands"), &RecordingCommands, cString::sprintf("\"%s\"", *strescape(recording->FileName(), "\\\"$"))));
         if (Key != kNone)
            state = menu->ProcessKey(Key);
         return state;
@@ -2497,7 +2498,7 @@
      Add(new cMenuEditIntItem( tr("Setup.DVB$Subtitle languages"),    &numSubtitleLanguages, 0, I18nLanguages()->Size()));
      for (int i = 0; i < numSubtitleLanguages; i++)
          Add(new cMenuEditStraItem(tr("Setup.DVB$Subtitle language"), &data.SubtitleLanguages[i], I18nLanguages()->Size(), &I18nLanguages()->At(0)));
-     Add(new cMenuEditIntItem( tr("Setup.DVB$Subtitle offset"),                  &data.SubtitleOffset,       -50, 50));
+     Add(new cMenuEditIntItem( tr("Setup.DVB$Subtitle offset"),                  &data.SubtitleOffset,      -100, 100));
      Add(new cMenuEditIntItem( tr("Setup.DVB$Subtitle foreground transparency"), &data.SubtitleFgTransparency, 0, 9));
      Add(new cMenuEditIntItem( tr("Setup.DVB$Subtitle background transparency"), &data.SubtitleBgTransparency, 0, 10));
      }
diff -ruN vdr-1.5.15/recording.c vdr-1.5.16/recording.c
--- vdr-1.5.15/recording.c	2008-02-16 14:31:39.000000000 +0100
+++ vdr-1.5.16/recording.c	2008-02-24 11:28:53.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recording.c 1.161 2008/02/16 13:31:39 kls Exp $
+ * $Id: recording.c 1.162 2008/02/24 10:28:53 kls Exp $
  */
 
 #include "recording.h"
@@ -1161,7 +1161,7 @@
 void cRecordingUserCommand::InvokeCommand(const char *State, const char *RecordingFileName)
 {
   if (command) {
-     cString cmd = cString::sprintf("%s %s \"%s\"", command, State, *strescape(RecordingFileName, "\"$"));
+     cString cmd = cString::sprintf("%s %s \"%s\"", command, State, *strescape(RecordingFileName, "\\\"$"));
      isyslog("executing '%s'", *cmd);
      SystemExec(cmd);
      }
diff -ruN vdr-1.5.15/remote.c vdr-1.5.16/remote.c
--- vdr-1.5.15/remote.c	2007-04-30 14:27:56.000000000 +0200
+++ vdr-1.5.16/remote.c	2008-02-23 15:14:46.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remote.c 1.57 2007/04/30 12:27:56 kls Exp $
+ * $Id: remote.c 1.59 2008/02/23 14:14:46 kls Exp $
  */
 
 #include "remote.h"
@@ -121,7 +121,7 @@
 bool cRemote::Put(uint64_t Code, bool Repeat, bool Release)
 {
   char buffer[32];
-  snprintf(buffer, sizeof(buffer), "%016LX", Code);
+  snprintf(buffer, sizeof(buffer), "%016llX", Code);
   return Put(buffer, Repeat, Release);
 }
 
@@ -185,7 +185,7 @@
             out = 0;
          if ((k & k_Repeat) != 0)
             repeatTimeout.Set(REPEATTIMEOUT);
-         lastActivity = time(NULL);
+         TriggerLastActivity();
          return enabled ? k : kNone;
          }
       else if (!WaitMs || !keyPressed.TimedWait(mutex, WaitMs) && repeatTimeout.TimedOut())
@@ -198,6 +198,11 @@
       }
 }
 
+void cRemote::TriggerLastActivity(void)
+{
+  lastActivity = time(NULL);
+}
+
 // --- cRemotes --------------------------------------------------------------
 
 cRemotes Remotes;
diff -ruN vdr-1.5.15/remote.h vdr-1.5.16/remote.h
--- vdr-1.5.15/remote.h	2007-04-30 14:37:37.000000000 +0200
+++ vdr-1.5.16/remote.h	2008-02-23 15:38:47.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remote.h 1.40 2007/04/30 12:37:37 kls Exp $
+ * $Id: remote.h 1.41 2008/02/23 14:38:47 kls Exp $
  */
 
 #ifndef __REMOTE_H
@@ -67,6 +67,9 @@
   static eKeys Get(int WaitMs = 1000, char **UnknownCode = NULL);
   static time_t LastActivity(void) { return lastActivity; }
       ///< Absolute time when last key was delivered by Get().
+  static void TriggerLastActivity(void);
+      ///< Simulates user activity, for instance to keep the current menu open
+      ///< even if no remote control key has been pressed.
   };
 
 class cRemotes : public cList<cRemote> {};
diff -ruN vdr-1.5.15/shutdown.c vdr-1.5.16/shutdown.c
--- vdr-1.5.15/shutdown.c	2008-01-13 15:27:29.000000000 +0100
+++ vdr-1.5.16/shutdown.c	2008-02-24 11:29:00.000000000 +0100
@@ -6,7 +6,7 @@
  *
  * Original version written by Udo Richter <udo_richter@gmx.de>.
  *
- * $Id: shutdown.c 1.4 2008/01/13 14:27:29 kls Exp $
+ * $Id: shutdown.c 1.5 2008/02/24 10:29:00 kls Exp $
  */
 
 #include "shutdown.h"
@@ -130,7 +130,7 @@
 void cShutdownHandler::CallShutdownCommand(time_t WakeupTime, int Channel, const char *File, bool UserShutdown)
 {
   time_t Delta = WakeupTime ? WakeupTime - time(NULL) : 0;
-  cString cmd = cString::sprintf("%s %ld %ld %d \"%s\" %d", shutdownCommand, WakeupTime, Delta, Channel, *strescape(File, "\"$"), UserShutdown);
+  cString cmd = cString::sprintf("%s %ld %ld %d \"%s\" %d", shutdownCommand, WakeupTime, Delta, Channel, *strescape(File, "\\\"$"), UserShutdown);
   isyslog("executing '%s'", *cmd);
   int Status = SystemExec(cmd, true);
   if (!WIFEXITED(Status) || WEXITSTATUS(Status))
diff -ruN vdr-1.5.15/skinclassic.c vdr-1.5.16/skinclassic.c
--- vdr-1.5.15/skinclassic.c	2008-02-17 15:23:36.000000000 +0100
+++ vdr-1.5.16/skinclassic.c	2008-02-23 11:31:58.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: skinclassic.c 1.25 2008/02/17 14:23:36 kls Exp $
+ * $Id: skinclassic.c 1.27 2008/02/23 10:31:58 kls Exp $
  */
 
 #include "skinclassic.h"
@@ -233,14 +233,15 @@
 {
   if (Total > 0 && Total > Shown) {
      int yt = Top;
-     int yb = yt + Height - 1;
+     int yb = yt + Height;
      int st = yt;
      int sb = yb;
-     int tt = st + (sb - st + 1) * Offset / Total;
-     int tb = tt + (sb - st + 1) * Shown / Total;
+     int th = max(int((sb - st) * double(Shown) / Total + 0.5), ScrollWidth);
+     int tt = min(int(st + (sb - st) * double(Offset) / Total + 0.5), sb - th);
+     int tb = min(tt + th, sb);
      int xl = x3 - ScrollWidth;
-     osd->DrawRectangle(xl, st, x3 - 1, sb, Theme.Color(clrMenuScrollbarTotal));
-     osd->DrawRectangle(xl, tt, x3 - 1, tb, Theme.Color(clrMenuScrollbarShown));
+     osd->DrawRectangle(xl, st, x3 - 1, sb - 1, Theme.Color(clrMenuScrollbarTotal));
+     osd->DrawRectangle(xl, tt, x3 - 1, tb - 1, Theme.Color(clrMenuScrollbarShown));
      }
 }
 
diff -ruN vdr-1.5.15/skinsttng.c vdr-1.5.16/skinsttng.c
--- vdr-1.5.15/skinsttng.c	2008-02-17 15:23:45.000000000 +0100
+++ vdr-1.5.16/skinsttng.c	2008-02-23 11:23:44.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: skinsttng.c 1.26 2008/02/17 14:23:45 kls Exp $
+ * $Id: skinsttng.c 1.28 2008/02/23 10:23:44 kls Exp $
  */
 
 // Star Trek: The Next Generation® is a registered trademark of Paramount Pictures
@@ -442,13 +442,14 @@
   if (Total > 0 && Total > Shown) {
      int h  = lineHeight;
      int yt = Top;
-     int yb = yt + Height - 1;
+     int yb = yt + Height;
      int st = yt + h + Gap;
      int sb = yb - h - Gap;
-     int tt = st + (sb - st + 1) * Offset / Total;
-     int tb = tt + (sb - st + 1) * Shown / Total;
-     osd->DrawRectangle(x5, st, x5 + ScrollWidth - 1, sb, Theme.Color(clrMenuScrollbarTotal));
-     osd->DrawRectangle(x5, tt, x5 + ScrollWidth - 1, tb, Theme.Color(clrMenuScrollbarShown));
+     int th = max(int((sb - st) * double(Shown) / Total + 0.5), ScrollWidth);
+     int tt = min(int(st + (sb - st) * double(Offset) / Total + 0.5), sb - th);
+     int tb = min(tt + th, sb);
+     osd->DrawRectangle(x5, st, x5 + ScrollWidth - 1, sb - 1, Theme.Color(clrMenuScrollbarTotal));
+     osd->DrawRectangle(x5, tt, x5 + ScrollWidth - 1, tb - 1, Theme.Color(clrMenuScrollbarShown));
      osd->DrawRectangle(x5, yt, x6 - 1, yt + h - 1, frameColor);
      osd->DrawEllipse  (x6, yt, x7 - 1, yt + h - 1, frameColor, 5);
      osd->DrawRectangle(x5, yb - h, x6 - 1, yb - 1, frameColor);
diff -ruN vdr-1.5.15/vdr.c vdr-1.5.16/vdr.c
--- vdr-1.5.15/vdr.c	2008-02-10 15:23:31.000000000 +0100
+++ vdr-1.5.16/vdr.c	2008-02-23 16:36:01.000000000 +0100
@@ -22,7 +22,7 @@
  *
  * The project's page is at http://www.cadsoft.de/vdr
  *
- * $Id: vdr.c 1.310 2008/02/10 14:23:31 kls Exp $
+ * $Id: vdr.c 1.312 2008/02/23 15:36:01 kls Exp $
  */
 
 #include <getopt.h>
@@ -730,7 +730,7 @@
         // Make sure we have a visible programme in case device usage has changed:
         if (!EITScanner.Active() && cDevice::PrimaryDevice()->HasDecoder() && !cDevice::PrimaryDevice()->HasProgramme()) {
            static time_t lastTime = 0;
-           if (Now - lastTime > MINCHANNELWAIT) {
+           if (!Menu && Now - lastTime > MINCHANNELWAIT) { // !Menu to avoid interfering with the CAM if a CAM menu is open
               cChannel *Channel = Channels.GetByNumber(cDevice::CurrentChannel());
               if (Channel && (Channel->Vpid() || Channel->Apid(0))) {
                  if (!Channels.SwitchTo(cDevice::CurrentChannel()) // try to switch to the original channel...
@@ -877,7 +877,9 @@
                            }
                         if (cDevice::PrimaryDevice()->HasDecoder() && !cDevice::PrimaryDevice()->HasProgramme()) {
                            // the previous SwitchChannel() has switched away the current live channel
-                           Channels.SwitchTo(Timer->Channel()->Number()); // avoids toggling between old channel and black screen
+                           cDevice::SetAvoidDevice(Device);
+                           if (!Channels.SwitchTo(cDevice::CurrentChannel())) // try to switch to the original channel on a different device...
+                              Channels.SwitchTo(Timer->Channel()->Number()); // ...or avoid toggling between old channel and black screen
                            Skins.Message(mtInfo, tr("Upcoming recording!"));
                            }
                         }
